#include <avr/io.h>
#include <util/delay.h>
#include "led_display.h"


volatile struct disp_t disp;


const int disp_znaki[] = DISP_ZNAKI;
const int disp_segm[]  = DISP_SEGM;


void init_display(void){

	disp.znak[0]	= 10;
	disp.znak[1]	= 10;
	disp.znak[2]	= 10;
	disp.znak[3]	= 10;
	disp.kropka[0]	= 0;
	disp.kropka[1]	= 0;
	disp.kropka[2]	= 0;
	disp.kropka[3]	= 0;
	disp.dwukropek	= 0;
	
	disp.licznik	= 0;
	disp.licznik2	= 0;

}


void display(void){
	
	if( disp.licznik >= 4 )
	{
		disp.licznik = 0;
		
		disp.licznik2++;
		if( disp.licznik2 > 2 )
			disp.licznik2=0;
	}
	
	PORTD = DISP_PUSTE;
	
	PORTC = disp_segm[ disp.licznik ];
	
	if( disp.licznik == 0 && disp.dwukropek != 0 )
		PORTC |= disp_segm[4];


	if( ( disp.znak[disp.licznik] != 1 && disp.znak[disp.licznik] != 10) || disp.licznik2 == 0 )
	{
		PORTD = disp_znaki[ disp.znak[disp.licznik] ];
		
		if( disp.kropka[disp.licznik] != 0 )
			PORTD &= DISP_KROPKA;
	}
	else
		PORTD = DISP_PUSTE;

	disp.licznik++;
	

}


void show_digit(int liczba){

	int znak3, znak2, znak1, znak0;
	
	znak3 = liczba % 10;
	
	liczba = liczba / 10;
	znak2 = liczba % 10;
	
	liczba = liczba / 10;
	znak1 = liczba % 10;
	
	liczba = liczba / 10;
	znak0 = liczba % 10;
	
	if( znak0 == 0 )
	{
		if( znak1 == 0 )
		{
			if( znak2 == 0 )
			{
				znak2 = 10;
			}
			znak1 = 10;
		}
		znak0 = 10;
	}
	
	disp.znak[3] = znak3;
	disp.znak[2] = znak2;
	disp.dwukropek = 0;
	disp.znak[1] = znak1;
	disp.znak[0] = znak0;
}

void show_time(int liczba){

	int godz = (liczba / 60) %24;
	int min = liczba % 60;
	
	disp.znak[3] = min % 10;
	disp.znak[2] = min / 10;
	disp.dwukropek = 1;
	disp.znak[1] = godz % 10;
	disp.znak[0] = ( godz / 10 == 0 ? 10 : godz/10 );

}
